package models

import "time"

type Result int32

const (
    NotTested               Result = 0
    Testing                 Result = 1
    Accepted                Result = 2
    TimeLimitExceeded       Result = 3
    MemoryLimitExceeded     Result = 4
    CompilationError        Result = 5
    SystemFailDuringTesting Result = 6
)

func (result Result) Valid() error {
    switch result {
    case NotTested, Accepted, TimeLimitExceeded, MemoryLimitExceede, CompilationError, SystemFailDuringTesting:
        return nil
    }
    return lib.ErrBadResult
}
